import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

////////////////////////////////////////////////////////////////////
//
//		CLASS : TimeVisualWin
//		=================
//     the window is used for showing execution time visualization information.
//
//     Last_Modified: On 4/8,
//		try to use only one thread for all visualizations
//		this is proper only for using one window 
//     Last_Modified: On 6/24,
// 		add a parameter to ctor for startTime for running application
//     Last_Modified: On 6/26,
//		add one more parameter to tell the current appl is running 
//		or not.
////////////////////////////////////////////////////////////////////

class TimeVisualWin extends Frame { 
  int vwWidth = 600, vwHeight = 400;
  String JevServHost;           // the host name Jeeves Server runs on
  String PortNo;                // the socket Port No. Jeeves Server uses
  VisualTime timevisual = null;
  Applet currapplet;
  String userID, applID;
  String repIP, repPort, repDBA;
  long startTime;
  vdceapp appl = null; 

  public TimeVisualWin(Applet currApplet, vdceapp appl, String hostname, String portno,
	       String userID, String applID, long startTime, String repIP, 
	       String repPort, String repDBA) {
    super();
    this.appl = appl;
    setTitle("Execution Time Visualization Window");
    currapplet  = currApplet;
    JevServHost = hostname;
    this.userID = userID;
    this.applID = applID;
    this.repIP  = repIP;
    this.repPort = repPort;
    this.repDBA  = repDBA;
    this.startTime = startTime;
    PortNo      = portno;
    setLayout(new BorderLayout());
    Panel p = new Panel();
    add("South", p);
    p.add(new Button("ExecTime"));
    p.add(new Button("CLOSE"));
    resize(vwWidth, vwHeight);
    show();
  }

  public boolean action(Event evt, Object obj) {
     if (evt.target instanceof Button) {
         if ("CLOSE".equals(obj)) {
             System.out.println("CLOSE");
	     if (timevisual != null) {
	        timevisual.die = true;
		timevisual.destroy();
		timevisual = null;
	      }
	     if (appl.eTimevisualWin != null)
		 appl.eTimevisualWin = null;
	     dispose();
             return true;
          }
         if ("ExecTime".equals(obj)) {
	 if (timevisual == null) {
	     System.out.println("in mwin..appl.run=" + appl.run);
	     timevisual = new VisualTime(this, currapplet, JevServHost, 
			  PortNo, userID, applID, startTime, appl.run,
			  repIP, repPort, repDBA);
    	     add("Center", timevisual);
	     timevisual.die = false;
 	     timevisual.visualType = 0;
	     new Thread(timevisual).start();
	  }
	     return true;
	  }
      }
     return false;
  }
}
